Bug 190189 - (PyQt4) Review Request: PyQt4: Python bindings for Qt4
Review Request: PyQt4: Python bindings for Qt4
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mamoru TASAKA
Fedora Extras Quality Assurance
: Reopened
Depends On: 214193 289321
Blocks: 240373
  Show dependency treegraph
 
Reported: 2006-04-28 12:50 EDT by Rex Dieter
Modified: 2009-07-02 14:46 EDT (History)
10 users (show)

See Also:
Fixed In Version: 4.2-8.fc7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-10-15 17:29:42 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mtasaka: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)
rpmlint output for PyQt4-devel package (24.50 KB, text/plain)
2007-05-15 17:51 EDT, Bryan O'Sullivan
no flags Details

  None (edit)
Comment 1 Rex Dieter 2006-04-28 12:52:41 EDT
For devel/fc6 branch only, since it requires sip >= 4.4.2
Also requires qt4 (see bug #188180)
Comment 2 Rex Dieter 2006-05-12 13:20:13 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SPECS/PyQt4-4.0-0.6.beta1.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/all/SRPMS.stable/PyQt4-4.0-0.6.beta1.src.rpm

%changelog
* Fri May 12 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.0-0.6.beta1
- drop BR: qt4-MySQL qt4-ODBC qt4-PostgreSQL
- drop usage of (undefined) %%sip_min
Comment 3 Rex Dieter 2006-07-19 11:41:35 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SPECS/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/all/SRPMS.stable/PyQt4-4.0.1-1.src.rpm

%changelog
* Sun Jul 16 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.0.1-1
- PyQt-4.0.1

* Mon Jun 12 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.0-1
- PyQt-4.0(final)
- BR: sip-devel >= 4.4.4 (see bug #199430)
Comment 4 John Mahowald 2006-07-29 18:03:30 EDT
Not building on x86_64:

+ /usr/bin/python configure.py -q /usr/bin/qmake4
Error: /usr/bin/qmake4 failed to create a makefile. Make sure you have a
working Qt v4 qmake on your PATH or use the -q argument to explicitly specify a
working Qt v4 qmake.
Determining the layout of your Qt installation...
Comment 5 Rex Dieter 2006-07-30 14:13:22 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SPECS/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/all/SRPMS.stable/PyQt4-4.0.1-2.src.rpm

%changelog
* Sat Jul 29 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.0.1-2
- fix reference(s) to qmake(4)
Comment 6 John Mahowald 2006-08-18 12:54:53 EDT
Build failed. devel x86_64.

Traceback (most recent call last):
  File "configure.py", line 1132, in ?
    main(sys.argv)
  File "configure.py", line 1099, in main
    pyqt.check_modules()
  File "configure.py", line 124, in check_modules
    check_module("QtGui", "qwidget.h", "QWidget()")
  File "configure.py", line 403, in check_module
    if check_class(incfile, ctor, mname):
  File "configure.py", line 430, in check_class
    return compile_qt_program(cfgtest, mname)
  File "configure.py", line 359, in compile_qt_program
    exe, build = makefile.build_command(name)
  File "/usr/lib64/python2.4/site-packages/sipconfig.py", line 1622, in
build_command
    build.append(self.required_string("CXX"))
  File "/usr/lib64/python2.4/site-packages/sipconfig.py", line 781, in
required_string
    raise ValueError, "\"%s\" must have a non-empty value" % name
ValueError: "CXX" must have a non-empty value
Comment 7 Rex Dieter 2006-08-18 13:26:43 EDT
Offhand, I'd say looks like a bug in sip.  It's not returning a value for CXX.
Comment 8 Rex Dieter 2006-08-18 13:30:07 EDT
On my rhel4 box, with latest sip
/usr/lib/python2.3/site-packages/sipconfig.py contains
   'CXX':                      'g++'

What does your sipconfig contain?
Comment 9 Rex Dieter 2006-08-28 08:20:55 EDT
FYI, PyQt4 doesn't build against qt4-4.2 (yet), so don't bother trying to build
on/for fc6.
Comment 10 Rex Dieter 2006-08-28 08:24:13 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SPECS/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/all/SRPMS.stable/PyQt4-4.0.1-3.src.rpm

%changelog
* Mon Aug 28 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.0.1-3
- BR: qt4-devel < 4.2
Comment 11 Rex Dieter 2006-10-11 10:26:31 EDT
qt4-4.2.0 support appears imminent:
http://www.riverbankcomputing.com/Downloads/Snapshots/PyQt4/ChangeLog
*cross fingers*
Comment 12 Rex Dieter 2006-11-06 09:26:45 EST
Woo hoo, the wait is finally over.  The bad news is that PyQt4-4.1 requires sip-4.5

Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SPECS/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/all/SRPMS.stable/PyQt4-4.1-1.src.rpm

%changelog
* Mon Nov 06 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1-1
- PyQt4-4.1
Comment 13 Rex Dieter 2006-11-06 16:35:43 EST
FYI, sip-4.5 has been added to rawhide, see bug #214193
Comment 14 Rex Dieter 2006-11-29 12:59:50 EST
Yay, sip-4.5 will also be landing on FC-5/FC-6 soon too (currently in
updates-testing), see bug #208847

Comment 15 Neal Becker 2006-12-07 20:09:11 EST
rpmbuild --rebuild PyQt4-4.1-1.src.rpm 
[ ... chug ...]
ERROR   0001: file '/usr/bin/pylupdate4' contains a standard 
rpath '/usr/lib64' in [/usr/lib64]
ERROR   0001: file '/usr/bin/pyrcc4' contains a standard rpath '/usr/lib64' in 
[/usr/lib64]
Comment 16 Neal Becker 2006-12-08 07:50:47 EST
I'm trying /usr/share/doc/PyQt4-devel-4.1/examples/tools/qtdemo/qtdemo.py.

Don't know who's causing this, but view an example, (say, main window), and 
click on "Show Documentation" doesn't work.  Shows raw xml and complains about 
not being able to find stuff under PyQt3-something.
Comment 17 Rex Dieter 2006-12-08 09:53:27 EST
AFAICT, the qtdemo.py example likely only works 100% if you have qt4-doc
installed (it worksforme).  Then, you can compare qtdemo.oy against how
qtdemo-qt works (it should be identical).
Comment 18 Neal Becker 2006-12-08 09:57:16 EST
rpm -q qt4-doc
qt4-doc-4.2.2-1.fc6

Must be some other problem.
Comment 19 Rex Dieter 2006-12-08 09:59:49 EST
you may also have qt-devel-docs installed (?), which may be interfering (they
both provide something called qtdemo).
Comment 20 Neal Becker 2006-12-08 10:02:28 EST
rpm -q qt-devel-docs
package qt-devel-docs is not installed
Comment 21 Rex Dieter 2006-12-08 10:11:39 EST
OK, it's qt-devel's 'assistant' running interference (not qt's qtdemo) here.
Comment 22 Rex Dieter 2006-12-08 10:13:59 EST
Root cause of problems running with "Show Documentation", is that it assumes the
presence of qt4's assistant, which we install as assistant-qt4 (to avoid file
conflicts with qt(3)'s assistant).
Comment 23 Rex Dieter 2006-12-08 11:30:36 EST
Here's a quick-n-dirty workaround:
export PATH=/usr/lib/qt4/bin:$PATH (or /usr/lib64/qt4/bin if on x86_64)
before running qtdemo.py
Comment 24 Rex Dieter 2006-12-14 11:32:29 EST
PyQt4-4.1.1 hit the streets, (haven't had a chance to track down the rpath
issue(s) yet):

%changelog
* Mon Dec 11 2006 Rex Dieter <rexdieter[AT]usres.sf.net> 4.1.1-1
- PyQt4-4.1.1
- BR: sip-devel >= 4.5.1

Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SPECS/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/all/SRPMS.stable/PyQt4-4.1.1-1.src.rpm

Bad news, is that this *again* needs a sip upgrade.  *sigh*.  Maybe we'll have
to resign ourselves to target this only for F*7.
Comment 25 Rex Dieter 2007-04-12 10:27:00 EDT
%changelog
* Wed Apr 11 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 4.2-1
- PyQt4-4.2

Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SPECS/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/all/SRPMS.stable/PyQt4-4.2-1.src.rpm


Comment 26 Bryan O'Sullivan 2007-05-15 17:18:10 EDT
SPEC URL problem: You don't have permission to access
/apt/kde-redhat/SPECS/PyQt4.spec on this server.
Comment 27 Bryan O'Sullivan 2007-05-15 17:51:04 EDT
Source RPM passes rpmlint OK, but there are problems with the binary packages:

$ rpmlint /home/bos/downloads/RPMS/x86_64/PyQt4-4.2-1.fc7.x86_64.rpm
E: PyQt4 non-executable-script
/usr/lib/python2.5/site-packages/PyQt4/uic/pyuic.py 0644
E: PyQt4 script-without-shebang /usr/bin/pyuic4
E: PyQt4 binary-or-shlib-defines-rpath
/usr/lib/python2.5/site-packages/PyQt4/QtDesigner.so
['/home/bos/downloads/BUILD/PyQt-x11-gpl-4.2/qpy/QtDesigner']

The first of these is a non-problem, but the second two are definitely issues. 
You can use chrpath to remove the rpath from the shared object if necessary.

I'm attaching the rpmlint warnings for the -devel package, because they're
voluminous.  Some of them can be ignored (the dependency on /usr/bin/env), but
the spurious perms should be fixed.
Comment 28 Bryan O'Sullivan 2007-05-15 17:51:38 EDT
Created attachment 154779 [details]
rpmlint output for PyQt4-devel package
Comment 29 Rex Dieter 2007-05-16 11:37:47 EDT
thanks, it'll likely be a few days (at least) before I get to updating anything
here (working on F7 kde stuff), so any other feedback, MUST blockers you find in
the meantime would be helpful.

Comment 30 Alex Lancaster 2007-07-10 22:34:08 EDT
Any movement on this package?  It would be great to get PyQt4 into Fedora >=7
because I need it for packaging the new version of Picard (MusicBrainz tagger):  

http://wiki.musicbrainz.org/PicardQt

I can pick up the review, if necessary.
Comment 31 Bryan O'Sullivan 2007-07-10 22:54:52 EDT
Alex: feel free to reassign to yourself, if you have time for this :-)
Comment 32 Alex Lancaster 2007-07-10 23:04:02 EDT
(In reply to comment #31)
> Alex: feel free to reassign to yourself, if you have time for this :-)

Thanks, I'll wait until I hear from Rex about the status of the package and see
how much time I have then... ;)  Otherwise, will you continue to review the package?
Comment 33 Rex Dieter 2007-07-11 07:37:41 EDT
all that's missing is a review(er), only outstanding issues are those from
comment #27.  Patches welcome. :)
Comment 34 Bryan O'Sullivan 2007-07-16 19:30:21 EDT
Rex: I have time to review this, but not to generate patches against the
problems in comment #27.  Given that, how would you like to proceed?
Comment 35 Rex Dieter 2007-07-16 19:34:45 EDT
review, as usual, I'll (eventually) deal with all blockers (oddly, I didn't see
any rpath issues in my own mock builds, but maybe I missed something).
Comment 36 Neal Becker 2007-07-16 20:03:11 EDT
I tried this on fc7 and needed a couple of changes.  I don't know what are the 
best fixes.
diff -r f680525e26ba PyQt4.spec
--- a/PyQt4.spec	Mon Jul 16 20:02:14 2007 -0400
+++ b/PyQt4.spec	Mon Jul 16 20:02:27 2007 -0400
@@ -57,8 +57,9 @@ fi
 %build
 
 #QT4DIR="$(pkg-config --variable=prefix QtCore || echo %{_libdir}/qt4)"
-QT4DIR=%{_qt4_prefix}
-PATH=%{_qt4_bindir}:$PATH ; export PATH
+#QT4DIR=%{_qt4_prefix}
+QT4DIR=/usr/lib64/qt4
+PATH=$QT4DIR/bin:$PATH ; export PATH
 # configure.py isn't smart enough to either use qmake or QMAKEPATH
 QMAKESPEC=$QT4DIR/mkspecs/linux-g++; export QMAKESPEC
 %if "%{_lib}" == "lib64"
@@ -75,6 +76,7 @@ rm -rf $RPM_BUILD_ROOT
 
 make install DESTDIR=$RPM_BUILD_ROOT
 
+chrpath --delete 
$RPM_BUILD_ROOT/usr/lib/python2.5/site-packages/PyQt4/QtDesigner.so 
 
 %clean
 rm -rf $RPM_BUILD_ROOT
Comment 37 Rex Dieter 2007-07-17 08:58:32 EDT
%_qt4_prefix,%_qt4_bindir is (should be!) defined by qt4-devel's
/etc/rpm/macros.qt4, but %{_qt4_bindir} is broken in qt4 < 4.3.0-8 (4.3.0-8 is
currently in updates-testing).

I'll fix it so that it "just works", and add the chrpath in the next build. 
Still awaiting review blockers... (Bryan?).

Comment 38 Rex Dieter 2007-07-17 15:26:12 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4-4.2-2.src.rpm

%changelog
* Tue Jul 17 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 4.2-2
- remove rpath from QtDesigner.so
- BR: qt4-devel > 4.3.0-8
Comment 39 Neal Becker 2007-07-17 17:04:26 EDT
Will this work on f7?  yum  --enablerepo=updates-testing info qt4-devel
shows only qt4-devel-4.3.0-2.bc7
Comment 40 Rex Dieter 2007-07-17 17:08:28 EDT
qt-4.3.0-8 had been in updates-testing for ~1 week, pushed to stable today.
Comment 41 Bernhard Schauer 2007-07-24 05:07:00 EDT
In the spec file that comes with #38 there is an error in the install section:

# fix/remove rpath
chrpath --delete $RPM_BUILD_ROOT%{_python_sitelib}/PyQt4/QtDesigner.so

_python_sitelib should be python_site_lib, cause the first one is never defined.
Comment 42 Bernhard Schauer 2007-07-24 05:11:32 EDT
ok. also my version was wrong: python_sitelib should be the name...
Comment 43 Rex Dieter 2007-07-30 16:31:00 EDT
fyi, PyQt-4.3 released today, but it requires sip-3.7 (not yet in rawhide), so
please continue with review of PyQt4-4.2.

Alex, Bryan?


Comment 44 Bryan O'Sullivan 2007-07-30 16:41:06 EDT
I'll have a more complete review up later today.
Comment 45 Bryan O'Sullivan 2007-07-30 17:06:26 EDT
OK, here's my review.

The following files most likely belong in the -devel package, not the main PyQt4
package:

/usr/bin/pylupdate4
/usr/bin/pyrcc4
/usr/bin/pyuic4

Must fix rpmlint errors:

E: PyQt4 non-executable-script
/usr/lib/python2.5/site-packages/PyQt4/uic/pyuic.py 0644
E: PyQt4 script-without-shebang /usr/bin/pyuic4
E: PyQt4 binary-or-shlib-defines-rpath
/usr/lib/python2.5/site-packages/PyQt4/QtDesigner.so
['/home/bos/rpms/BUILD/PyQt-x11-gpl-4.2/qpy/QtDesigner']

Also, it would be good to fix the 228 (!) rpmlint warnings on the -devel
package, which I attached several months ago.

Beyond the above, all other MUSTs look good.
Comment 46 Rex Dieter 2007-08-02 14:16:36 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4-4.2-3.src.rpm

%changelog
* Thu Aug 02 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 4.2-3
- fix python_sitelib typo (wrt chrpath call)
- move %%_bindir stuff to -devel
- mark %%doc examples non-executable
- add shebang to %%_bindir/pyuic4
Comment 47 Rex Dieter 2007-08-17 08:16:44 EDT
ping Bryan, afaict, I've fixed the MUST items you asked for...
Comment 48 Mamoru TASAKA 2007-08-17 13:55:08 EDT
I just did a quick look and have not rechecked this package
fully, however:

* Rebuild fails at least on ppc64
  http://koji.fedoraproject.org/koji/taskinfo?taskID=107108
* This package contains arch-dependent modules and putting them under
  python_sitelib is not proper.
* Please update license tag.
* Would you have any idea what is causing rpath issue?
  the build log on i386 can be found under:
  http://koji.fedoraproject.org/koji/taskinfo?taskID=107155
  (I have not checked the build log)
Comment 49 Rex Dieter 2007-08-17 15:52:49 EDT
> sitelib, license tag

Will have to wait till next week when/if I have time (at least the sitelib 
part).

> * Rebuild fails at least on ppc64

some qt4 stuff has issues there, maybe not PyQt4's fault, but hard to 
speculate based on the build.log.

> rpath issue?
should be gone, we're now using chrpath -delete

Comment 50 Mamoru TASAKA 2007-08-26 02:06:44 EDT
ping?
Comment 51 Rex Dieter 2007-08-26 13:07:57 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4-4.2-4.src.rpm

%changelog
* Sun Aug 26 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 4.2-4
- use %%python_sitearch
- License: GPLv2
Comment 52 Rex Dieter 2007-08-26 13:11:30 EDT
The previous ppc64 issue was qt4's fault, which should be fixed latest qt4 
builds.
Comment 53 Mamoru TASAKA 2007-08-26 13:42:17 EDT
Still seems to not okay? (I just tried to rebuild -4 and
have not checked -4 yet)

http://koji.fedoraproject.org/koji/taskinfo?taskID=130289
Comment 54 Rex Dieter 2007-08-26 16:49:48 EDT
specfile had a typo in python_sitearch macro. respun .spec,srpm.
Comment 55 Rex Dieter 2007-08-26 18:30:07 EDT
ok, respun a second time, with successful build to confirm (see x86_64 dir in
spec/srpm URL).
Comment 56 Mamoru TASAKA 2007-08-26 21:30:42 EDT
(In reply to comment #55)
> ok, respun a second time, with successful build to confirm (see x86_64 dir in
> spec/srpm URL).

Do you mean the following?
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/x86_64/PyQt4-4.2-4.fc8.src.rpm

If so it is not okay yet.
http://koji.fedoraproject.org/koji/taskinfo?taskID=130842
Comment 57 Rex Dieter 2007-08-26 21:58:37 EDT
OK, so ppc64 is screwed atm, that isn't a blocker, i hope?
Comment 58 Mamoru TASAKA 2007-08-26 22:17:28 EDT
Well, then I will recheck -4 after I have lunch.
Comment 59 Mamoru TASAKA 2007-08-27 02:08:52 EDT
For 4.2-4:

** First from build log:
* Possibly missing files
----------------------------------------------------------
make[1]: Entering directory `/builddir/build/BUILD/PyQt-x11-gpl-4.2/designer'
install -m 755 -p "libpythonplugin.so"
"/usr/lib/qt4/plugins/designer/libpythonplugin.so"
install: cannot create regular file
`/usr/lib/qt4/plugins/designer/libpythonplugin.so': Permission denied
make[1]: [install_target] Error 1 (ignored)
cp -f -r /builddir/build/BUILD/PyQt-x11-gpl-4.2/designer/python
/usr/lib/qt4/plugins/designer/
cp: cannot create directory `/usr/lib/qt4/plugins/designer/python': Permission
denied
make[1]: [install_python] Error 1 (ignored)
----------------------------------------------------------
   - And it seems all files which may supposed to be installed
     under %_libdir/qt4/plugins/designer are missing.

* Dependency for -devel subpackage
  - I don't know about *.sip files well, however it seems that
    *.sip files included in -devel subpackage requires qt4-devel
    for "Requires".

* About "Qt License Agreement"
  - What does the following statement mean? (what is "valid
    Qt License Agreement"?)
#############################################################################
##
## Copyright (C) 2006-2006 Trolltech ASA. All rights reserved.
##
## This file is part of the example classes of the Qt Toolkit.
##
## Licensees holding a valid Qt License Agreement may use this file in
## accordance with the rights, responsibilities and obligations
## contained therein.  Please consult your licensing agreement or
## contact sales@trolltech.com if any conditions of this licensing
## agreement are not clear to you.
##
## Further information about Qt licensing is available at:
## http://www.trolltech.com/products/qt/licensing.html or by
## contacting info@trolltech.com.
##
## This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
## WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
##
#############################################################################

* Source
  - I tried to download source tarball from URL written as Source0,
    however it is not found.
    Also, the newest seems 4.3.
Comment 60 Rex Dieter 2007-08-27 15:22:11 EDT
> licensing

http://www.trolltech.com/products/qt/licensing.html
"Qt Open Source Edition Licensing"
addesses that, in short, qt(4) can/is dual licensed QPL/GPLv2, but as far as
fedora is concerned, it's only GPLv2


> Re: -devel Requires: qt4-devel

agreed.


> Re: designer plugin issue(s)

My builds mention:
The Designer plugin will be installed in /usr/lib64/qt4/plugins/designer
near the beginning, but then doesn't actually ever does anything with it. ??


> Re:  the newest seems 4.3.

Which requires a newer version of sip than we have in fedora/rawhide atm (per
comment #43 )
Comment 61 Mamoru TASAKA 2007-08-27 21:36:21 EDT
(In reply to comment #60)

> > Re: designer plugin issue(s)
> 
> My builds mention:
> The Designer plugin will be installed in /usr/lib64/qt4/plugins/designer
> near the beginning,
This is the same for i386 (with /usr/lib64 changed to /usr/lib)

> but then doesn't actually ever does anything with it. ??
The real issue is that, rebuild tries to install some files under
%_libdir/qt4/plugins/designer _directly_, not under 
$RPM_BUILD_ROOT%_libdir/qt4/plugins/designer.

> 
> > Re:  the newest seems 4.3.
> 
> Which requires a newer version of sip than we have in fedora/rawhide atm (per
> comment #43 )
Okay.
> 

Comment 62 Mamoru TASAKA 2007-09-05 11:36:32 EDT
ping?
Comment 63 Rex Dieter 2007-09-05 11:57:06 EDT
%changelog
* Mon Aug 27 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 4.2-5
- -devel: Requires: qt4-devel

spec (same URL): http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4.spec

Re: designer plugin:   it's not building, so nothing gets installed, no failures
here.  Long term, this can/should be fixed, but hopefully it's not a blocker (I
don't have the time/nrg to debug this atm).
Comment 64 Mamoru TASAKA 2007-09-06 08:47:52 EDT
(In reply to comment #63)
> Re: designer plugin:   it's not building, so nothing gets installed,
> no failures here. 
  - Well, what do you mean here? build.log shows:
-----------------------------------------------
rm -f libpythonplugin.so
g++ -shared -o libpythonplugin.so pluginloader.o moc_pluginloader.o   
-L/usr/lib -lpython2.5 -lQtScript -lQtXml -lQtGui -L/usr/X11R6/lib -lQtCore
-lQtDesigner -lpthread 
make[1]: Leaving directory `/builddir/build/BUILD/PyQt-x11-gpl-4.2/designer'
-----------------------------------------------
   So the seemingly-plugin "libpythonplugin.so" seems to be created
   actually, however installing this fails due to the issue
   on comment 59.
Comment 65 Rex Dieter 2007-09-06 09:34:52 EDT
my build.log doesn't include that, nor do my builds fail.  ??
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/x86_64/build.log
Comment 66 Mamoru TASAKA 2007-09-06 10:12:09 EDT
(In reply to comment #65)
> my build.log doesn't include that, nor do my builds fail.  ??
> http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/x86_64/build.log

Umm.. Actually it seems that ( for 4.2-5 ) libpythonplugin.so is 
built on both i386, ppc, but not on x86_64.

http://koji.fedoraproject.org/koji/getfile?taskID=149620&name=build.log
http://koji.fedoraproject.org/koji/getfile?taskID=149622&name=build.log
http://koji.fedoraproject.org/koji/getfile?taskID=149624&name=build.log

I found that on x86_64 build log says:
-----------------------------------------------------
Creating pyrcc4 Makefile...
Qt Designer plugin disabled because Python library is static <====
Creating pyqtconfig.py...
+ make -j2
------------------------------------------------------
Perhaps this needs investigating (on i386, ppc this comment is not seen)
Comment 67 Rex Dieter 2007-09-13 09:35:44 EDT
per comment #47...
ping Bryan, afaict, I've fixed the MUST items you asked for...
Comment 68 Mamoru TASAKA 2007-09-13 09:40:26 EDT
Rex, so how do you deal with libpythonplugin.so?
Comment 69 Rex Dieter 2007-09-13 09:52:28 EDT
It appears the configure.py isn't 64bit clean, hard-coding some library paths
-L.../lib looking for libpython, hopefully shouldn't be too hard to fix.
Comment 70 Rex Dieter 2007-09-13 09:56:35 EDT
Arg, looks like a bug in sip,
/usr/lib64/python2.5/site-packages/sipconfig.py
contains:
    'py_lib_dir':       '/usr/lib/python2.5/config',
should be:
    'py_lib_dir':       '/usr/lib64/python2.5/config',
Comment 71 Mamoru TASAKA 2007-10-01 08:59:47 EDT
Rex, now sip is updated (for rawhide/F-7, F-7 sip is perhaps
waiting for being pushed), would you check if your PyQt srpm works
with the newest sip?
Comment 72 Rex Dieter 2007-10-03 11:35:16 EDT
sync'd my local rawhide mirror, testing builds now...
Comment 73 Rex Dieter 2007-10-03 12:47:31 EDT
Ugh, still broken, must be something else now.

Brian hasn't responded for 2+ mos, removing his review assignment so that
someone else can step in.
Comment 74 Rex Dieter 2007-10-03 12:57:42 EDT
(sorry, Bryan, my bad for the mispelling)
Comment 75 Rex Dieter 2007-10-03 13:24:56 EDT
OK, patched that (similar prob as with the sip bug, dev's *assuming* python
installed into prefix/lib):

Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4-4.2-6.src.rpm

%changelog
* Wed Oct 03 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 4.2-6
- 64bit QtDesigner patch
Comment 76 Mamoru TASAKA 2007-10-03 14:14:47 EDT
Assigning to me.
Comment 77 Mamoru TASAKA 2007-10-04 02:49:24 EDT
* Well, still installing libpythonplugin.so is not good.

make[1]: Entering directory `/builddir/build/BUILD/PyQt-x11-gpl-4.2/designer'
install -m 755 -p "libpythonplugin.so"
"/usr/lib64/qt4/plugins/designer/libpythonplugin.so"
install: cannot create regular file
`/usr/lib64/qt4/plugins/designer/libpythonplugin.so': Permission denied
make[1]: [install_target] Error 1 (ignored)
cp -f -r /builddir/build/BUILD/PyQt-x11-gpl-4.2/designer/python
/usr/lib64/qt4/plugins/designer/

Here libpythonplugin.so is surely rebuilt, however make tries
to install the plugin directly under %_libdir/qt4/plugins/designer, 
which must be %buildroot%_libdir/qt4/plugins/designer/

* Still fails on ppc64
  http://koji.fedoraproject.org/koji/taskinfo?taskID=181782
  Please mark ppc64 as ExcludeArch.
Comment 78 Rex Dieter 2007-10-04 08:52:22 EDT
Crazy, something must be different in my mock setup, because I certainly don't
see that, see
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/i386
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/x86_64
guess I'm going to have to give koji scratch builds a try.

Regardless, I hope that quirks between build environments isn't grounds for
blocking the review.
Comment 79 Rex Dieter 2007-10-04 08:54:02 EDT
OK, double-checked, my build.log contains that too, 
install -m 755 -p "libpythonplugin.so"
"/usr/lib/qt4/plugins/designer/libpythonplugin.so"
install: cannot create regular file
`/usr/lib/qt4/plugins/designer/libpythonplugin.so': Permission denied
make[1]: [install_target] Error 1 (ignored)
...
it's just not a fatal error.
Comment 80 Mamoru TASAKA 2007-10-04 09:30:04 EDT
Although make says it is not fatal, the fact that libpythonplugin.so
is not installed correctly should be fixed.
Comment 81 Rex Dieter 2007-10-04 09:43:37 EDT
Spec URL: http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4.spec
SRPM URL:
http://kde-redhat.unl.edu/apt/kde-redhat/SOURCES/PyQt4/PyQt4-4.2-7.src.rpm

%changelog
* Thu Oct 04 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 4.2-7
- fix QtDesigner plugin install
Comment 82 Rex Dieter 2007-10-04 09:52:19 EDT
oh, and just added
ExcludeArch: ppc64 
for now, until I get a chance to take a closer look.
Comment 83 Mamoru TASAKA 2007-10-04 11:21:00 EDT
Okay.

-------------------------------------------------------
    This package (PyQt4) is APPROVED by me
-------------------------------------------------------
Comment 84 Rex Dieter 2007-10-04 11:31:41 EDT
Rock, thanks for the review.

New Package CVS Request
=======================
Package Name: PyQt4
Short Description: Python bindings for Qt4
Owners: rdieter,than
Branches: FC-6 F-7 F-8 EL-5
InitialCC:
Cvsextras Commits: no
Comment 85 Jason Tibbitts 2007-10-04 15:39:27 EDT
CVS done.
Comment 86 Rex Dieter 2007-10-05 10:49:29 EDT
imported, initial builds done.
Comment 87 Mamoru TASAKA 2007-10-05 11:01:53 EDT
(Reopening to reassign)
Comment 88 Fedora Update System 2007-10-08 10:59:35 EDT
PyQt4-4.2-8.fc7 has been pushed to the Fedora 7 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update PyQt4'
Comment 89 Fedora Update System 2007-10-15 17:29:40 EDT
PyQt4-4.2-8.fc7 has been pushed to the Fedora 7 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.